searchNodes=[{"doc":"Instruments allows you to easily create and emit metrics from your application. Getting started with instruments is simple, all you do is use this module, and you're off to the races. defmodule MyModule do use Instruments def compute_something ( ) do Instruments . increment ( &quot;computations&quot; ) end end You can also create functions that are custom prefixed to avoide duplication in your code. See Instruments.CustomFunctions for more details. Metric Options All the functions in this module can be given an options keyword list, with one or both of the following keys: sample_rate : A float, determining the percentage chance this metric will be emitted. tags : A list of String tags that will be applied to this metric. Tags are useful for post-hoc grouping. For example , you could add instance type as a tag and visualize the difference between timing metrics of the same statistic across instance types to see which are the fastest . Here's an example of using options: @type user_type :: :administrator | :employee | :normal @spec my_function ( user_type , [ User ] ) :: :ok def my_function ( user_type , users ) do Instruments . histogram ( &quot;user_counts&quot; , Enum . count ( users ) , sample_rate : 0.5 , tags : [ &quot; \#{ user_type } &quot; ] ) end Now you can aggregate user counts by user type without emitting new stats Performance notes If a metric key has interpolation (such as &quot;my_metric.\#{Mix.env}&quot; ), the interpolation is removed and the metric name is converted to IOdata. This will prevent garbage being created in your process.","ref":"Instruments.html","title":"Instruments","type":"module"},{"doc":"Decrements a counter Decrements the counter with the key key by value .","ref":"Instruments.html#decrement/3","title":"Instruments.decrement/3","type":"macro"},{"doc":"Sets a gauge value Sets the Gauge with key key to value , overwriting the previous value. Gauges are useful for system metrics that have a specific value at a specific time.","ref":"Instruments.html#gauge/3","title":"Instruments.gauge/3","type":"macro"},{"doc":"Adds a value to a histogram Reports value to a histogram with key key . A Histogram is useful if you want to see aggregated percentages, and are often used when recording timings.","ref":"Instruments.html#histogram/3","title":"Instruments.histogram/3","type":"macro"},{"doc":"Increments a counter Increments the counter with name key by value .","ref":"Instruments.html#increment/3","title":"Instruments.increment/3","type":"macro"},{"doc":"Times the function function and returns its result This function allows you to time a function and send a metric in one call, and can often be easier to use than the Instruments.timing/3 function. For example this: def timed_internals ( ) do { run_time_micros , result } = :timer . tc ( &amp; other_fn / 0 ) Instruments . timing ( &quot;my.metric&quot; , run_time_micros ) result end Can be converted to: def timed_internals ( ) do Instruments . measure ( &quot;my.metric&quot; , &amp; other_fn / 0 ) end","ref":"Instruments.html#measure/3","title":"Instruments.measure/3","type":"macro"},{"doc":"Registers the following probes: erlang.memory : Reports how much memory is being used by the process , system , atom , binary and ets carriers. recon.alloc : Reports how much memory is being actively used by the VM. erlang.system.process_count : A gauge reporting the number of processes in the VM. erlang.system.port_count : A gauge reporting the number of ports in the VM. erlang.statistics.run_queue : A gauge reporting the VM's run queue. This number should be 0 or very low. A high run queue indicates your system is overloaded. erlang.scheduler_utilization : A gauge that reports the actual utilization of every scheduler in the system. See Instruments.Probes.Schedulers for more information","ref":"Instruments.html#register_vm_metrics/1","title":"Instruments.register_vm_metrics/1","type":"function"},{"doc":"Sends an event to DataDog This macro is useful if you want to record one-off events like deploys or metrics values changing.","ref":"Instruments.html#send_event/3","title":"Instruments.send_event/3","type":"macro"},{"doc":"Adds value to a set Statsd supports the notion of sets , which are unique values in a given flush. This adds value to a set with key key .","ref":"Instruments.html#set/3","title":"Instruments.set/3","type":"macro"},{"doc":"Reports a timed value If you're manually timing something, you can use this function to report its value. Timings are usually added to a histogram and reported as percentages. If you're interested in timing a function, you should also see Instruments.measure/3 .","ref":"Instruments.html#timing/3","title":"Instruments.timing/3","type":"macro"},{"doc":"Creates custom prefixed functions Often, a module will have functions that all have a common prefix. It's somewhat tedious to have to put this prefix in every call to every metric function. Using this module can help somewhat. When you use this module, it defines custom, module-specific metrics functions that include your prefix. For example: defmodule Prefixed do use Instruments.CustomFunctions , prefix : &quot;my.module&quot; def do_something ( ) do increment ( &quot;do_something_counts&quot; ) do_another_thing ( ) end def long_running ( ) do measure ( &quot;timed_fn&quot; , &amp; compute / 0 ) end defp compute ( ) , do : Process . sleep ( 10_000 ) defp do_another_thing , do : 3 end In the above example, we increment do_something_counts and timed_fn , yet the metrics emitted are my.module.do_something_counts and my.module.timed_fn .","ref":"Instruments.CustomFunctions.html","title":"Instruments.CustomFunctions","type":"module"},{"doc":"A behavior for a Probe. Modules that define probes are expected to implement all of the functions in this behaviour. A probe is created via the call to Instruments.Probe.probe_init/3 , and is then called every sample_interval milliseconds via the Instruments.Probe.probe_sample/1 function. The probe can then update its internal state and do any processing it requires. Every report_interval milliseconds, the probe is expected to emit its metric value.","ref":"Instruments.Probe.html","title":"Instruments.Probe","type":"behaviour"},{"doc":"See Instruments.Probe.Definitions.define!/3 .","ref":"Instruments.Probe.html#define!/3","title":"Instruments.Probe.define!/3","type":"function"},{"doc":"See Instruments.Probe.Definitions.define/3 .","ref":"Instruments.Probe.html#define/3","title":"Instruments.Probe.define/3","type":"function"},{"doc":"Called at least every report_interval milliseconds. This call reads the value of the probe, which is reported to the underlying statistics system. Return values can either take the form of a single numeric value, or a keyword list keys -&gt; numeric values. Nil values won't be reported to the statistics system.","ref":"Instruments.Probe.html#c:probe_get_value/1","title":"Instruments.Probe.probe_get_value/1","type":"callback"},{"doc":"Called when the probe's runner process receives an unknown message. You must return {:ok, state} . Any other return values will cancel further execution of the probe.","ref":"Instruments.Probe.html#c:probe_handle_message/2","title":"Instruments.Probe.probe_handle_message/2","type":"callback"},{"doc":"Called when the probe is created. The callback is passed the name of the probe, what kind of metric it's producing and the options the probe was created with. You must return {:ok, state} . The state will be passed back to you on subsequent callbacks. Any other return values will cancel further execution of the probe.","ref":"Instruments.Probe.html#c:probe_init/3","title":"Instruments.Probe.probe_init/3","type":"callback"},{"doc":"Resets the probe's state. You must return {:ok, state} . Any other return values will cancel further execution of the probe.","ref":"Instruments.Probe.html#c:probe_reset/1","title":"Instruments.Probe.probe_reset/1","type":"callback"},{"doc":"Called every sample_interval milliseconds. When called, the probe should perform its measurement and update its internal state. You must return {:ok, state} . Any other return values will cancel further execution of the probe.","ref":"Instruments.Probe.html#c:probe_sample/1","title":"Instruments.Probe.probe_sample/1","type":"callback"},{"doc":"","ref":"Instruments.Probe.html#t:datapoint/0","title":"Instruments.Probe.datapoint/0","type":"type"},{"doc":"","ref":"Instruments.Probe.html#t:probe_options/0","title":"Instruments.Probe.probe_options/0","type":"type"},{"doc":"","ref":"Instruments.Probe.html#t:probe_type/0","title":"Instruments.Probe.probe_type/0","type":"type"},{"doc":"","ref":"Instruments.Probe.html#t:probe_value/0","title":"Instruments.Probe.probe_value/0","type":"type"},{"doc":"","ref":"Instruments.Probe.html#t:state/0","title":"Instruments.Probe.state/0","type":"type"},{"doc":"A probe that reports erlang's internal CPU usage Any good system monitoring needs to understand how hard the CPU is working. In an Erlang ecosystem, this can be somewhat challenging becase when an Erlang system isn't busy, the BEAM vm keeps its schedulers in tight loops so they don't get descheduled by the operating system. This can make external CPU metrics like top report that the system is actually much busier than it is. This module reports Erlang's internal view of its scheduler utilization and is a better gauge of how loaded your system is. It reports two values, the total utilization, and a weighted utilization , which can be used as a proxy for CPU usage. To use this probe, add the following function somewhwere in your application's initialization: alias Instruments Probe . define! ( &quot;erlang.scheduler_utilization&quot; , :gauge , module : Probes.Schedulers , keys : ~w(weighted total) ) The probe will now report two metrics, erlang.scheduler_utilization.total and erlang.scheduler_utilization.total .","ref":"Instruments.Probes.Schedulers.html","title":"Instruments.Probes.Schedulers","type":"module"},{"doc":"The default stats reporter. Uses the Statix library.","ref":"Instruments.Statix.html","title":"Instruments.Statix","type":"module"},{"doc":"Callback implementation for Statix.connect/0 .","ref":"Instruments.Statix.html#connect/0","title":"Instruments.Statix.connect/0","type":"function"},{"doc":"Callback implementation for Statix.decrement/3 .","ref":"Instruments.Statix.html#decrement/3","title":"Instruments.Statix.decrement/3","type":"function"},{"doc":"Callback implementation for Statix.gauge/3 .","ref":"Instruments.Statix.html#gauge/3","title":"Instruments.Statix.gauge/3","type":"function"},{"doc":"Callback implementation for Statix.histogram/3 .","ref":"Instruments.Statix.html#histogram/3","title":"Instruments.Statix.histogram/3","type":"function"},{"doc":"Callback implementation for Statix.increment/3 .","ref":"Instruments.Statix.html#increment/3","title":"Instruments.Statix.increment/3","type":"function"},{"doc":"Callback implementation for Statix.measure/3 .","ref":"Instruments.Statix.html#measure/3","title":"Instruments.Statix.measure/3","type":"function"},{"doc":"Callback implementation for Statix.set/3 .","ref":"Instruments.Statix.html#set/3","title":"Instruments.Statix.set/3","type":"function"},{"doc":"Callback implementation for Statix.timing/3 .","ref":"Instruments.Statix.html#timing/3","title":"Instruments.Statix.timing/3","type":"function"},{"doc":"A behavoiur for reporters. Reporters emit values back to the underlying reporting system. Out of the box, Instruments provides Instruments.Statix , Instruments.StatsReporter.Logger , and Instruments.StatsReporter.Null reporters.","ref":"Instruments.StatsReporter.html","title":"Instruments.StatsReporter","type":"behaviour"},{"doc":"Connect to the reporter. This function is called by the system prior to using the reporter, any connections should be established in this function.","ref":"Instruments.StatsReporter.html#c:connect/0","title":"Instruments.StatsReporter.connect/0","type":"callback"},{"doc":"Decrement a key by the specified value","ref":"Instruments.StatsReporter.html#c:decrement/3","title":"Instruments.StatsReporter.decrement/3","type":"callback"},{"doc":"Set the value of the key to the specified value","ref":"Instruments.StatsReporter.html#c:gauge/3","title":"Instruments.StatsReporter.gauge/3","type":"callback"},{"doc":"Include the value in the histogram defined by key","ref":"Instruments.StatsReporter.html#c:histogram/3","title":"Instruments.StatsReporter.histogram/3","type":"callback"},{"doc":"Increment a key by the specified value","ref":"Instruments.StatsReporter.html#c:increment/3","title":"Instruments.StatsReporter.increment/3","type":"callback"},{"doc":"Measure the execution time of the provided function and include it in the metric defined by key","ref":"Instruments.StatsReporter.html#c:measure/3","title":"Instruments.StatsReporter.measure/3","type":"callback"},{"doc":"Write the value into the set defined by key","ref":"Instruments.StatsReporter.html#c:set/3","title":"Instruments.StatsReporter.set/3","type":"callback"},{"doc":"Include the timing in the key","ref":"Instruments.StatsReporter.html#c:timing/3","title":"Instruments.StatsReporter.timing/3","type":"callback"},{"doc":"","ref":"Instruments.StatsReporter.html#t:key/0","title":"Instruments.StatsReporter.key/0","type":"type"},{"doc":"","ref":"Instruments.StatsReporter.html#t:stats_return/0","title":"Instruments.StatsReporter.stats_return/0","type":"type"},{"doc":"A StatsReporter that logs to the Logger module.","ref":"Instruments.StatsReporter.Logger.html","title":"Instruments.StatsReporter.Logger","type":"module"},{"doc":"A StatsReporter module that throws out all logging messages.","ref":"Instruments.StatsReporter.Null.html","title":"Instruments.StatsReporter.Null","type":"module"},{"doc":"","ref":"Instruments.Probe.Errors.ProbeNameTakenError.html","title":"Instruments.Probe.Errors.ProbeNameTakenError","type":"exception"},{"doc":"Callback implementation for Exception.message/1 .","ref":"Instruments.Probe.Errors.ProbeNameTakenError.html#message/1","title":"Instruments.Probe.Errors.ProbeNameTakenError.message/1","type":"function"},{"doc":"You're blind without metrics. Metrics should also be easy to add to you application and have little performance impact. This module allows you to define metrics with ease and see inside your application. Instruments has the following types of metrics that closely mirror statsd. Counters : Allow you to increment or decrement a value. Gauges : Allow you to report a single value that changes over time Histograms : Values are grouped into percentiles Timings : Report a timed value in milliseconds Measurements : Measure the execution time of a function Sets : Add a value to a statsd set Events : Report an event like a deploy using arbitrary keys and values","ref":"overview.html","title":"Overview","type":"extras"},{"doc":"Reporting a metric is extremely simple; just use the Instruments module and call the appropriate function: defmodule ModuleThatNeedsMetrics do use Instruments def other_function ( ) do Process . sleep ( 150 ) end def metrics_function ( ) do Instruments . increment ( &quot;my.counter&quot; , 3 ) Instruments . measure ( &quot;metrics_function.other_fn_call&quot; , &amp; other_function / 0 ) end end","ref":"overview.html#basic-usage","title":"Overview - Basic Usage","type":"extras"},{"doc":"Often, all metrics inside a module have namespaced metrics. This is easy to accomplish using CustomFunctions defmodule RpcHandler do use Instruments.CustomFunctions , prefix : &quot;my_service.rpc&quot; def handle ( :get , &quot;/foo/bar&quot; ) do increment ( &quot;foo.bar&quot; ) end end The above example will increment the my_service.rpc.foo.bar metric by one.","ref":"overview.html#custom-namespaces","title":"Overview - Custom Namespaces","type":"extras"},{"doc":"Statix After the underlying Statix library is configured, Instruments requires little configuration. To configure Statix , include the following in your config/config.exs file: config :statix , prefix : &quot; \#{ Mix . env } &quot; , host : &quot;localhost&quot; , port : 15339 This should be pretty self-explanatory, other than you'll have a metric prefix of your Mix.env for all metrics, so if you defined a metric named my_server.requests_per_second it would be converted to prod.my_server.requests_per_second . More information can be found on the Statix GitHub page . Instruments-Specific Config There are a couple of Instruments specific application variables: reporter_module : The Instruments.StatsReporter that emits statistics for the application. Defaults to ` Instruments.Statix ` . fast_counter_report_interval : How often counters should send data to the reporter_module , in milliseconds. Defaults to 10 seconds . fast_counter_report_jitter_range : How much random jitter should be applied to the reporting interval, in milliseconds. Defaults to half a second before and after the reporting interval . probe_prefix : A global prefix to apply to all probes. statsd_port : The port that the statsd server listens on. Should be the same as the port in the statix configuration above . For example: config :instruments , reporter_module : Instruments.StatsReporter.Logger , fast_counter_report_interval : 30_000 , fast_counter_report_jitter_range : - 700 .. 700 , probe_prefix : &quot;probes&quot; , statsd_port : 15339","ref":"configuration.html","title":"Configuration","type":"extras"},{"doc":"A probe is a persistent system metric that's updated at a consistent rate. Probes can be either functions, or a module that implements the Instruments.Probe behaviour. If it's a module, its state is controlled by another process, all implementers need to worry about is the state transitions.","ref":"probes.html","title":"Probes","type":"extras"},{"doc":"First of all, probes must have unique names so their stats won't conflict with one another. This is enforced at runtime, since it's possible to define probes progammatically. Functions The simplest way to define a probe is to specify a function: Probe . define ( &quot;erlang.process_count&quot; , :gauge , function : fn -&gt; :erlang . system_info ( :process_count ) end , report_interval : 60_000 ) Since the above definiton doesn't pass in the sample_interval options, the sample interval is the same as the report interval. The metric will be sampled and reported every 60 seconds. MFA A simplification of the above example uses the :mfa option to specify a module, function and arguments to be called. For example, Probe . define ( &quot;erlang.process_count&quot; , :gauge , mfa : { :erlang , :system_info , [ :process_count ] } ) You can also have a function that returns a keyword list of stats and select which keys you want to report. The keys are added to the stat name Probe . define ( &quot;erlang.memory&quot; , :gauge , function : fn -&gt; :erlang . memory ( ) end , keys : [ :total , :atom , :processes ] , report_interval : 60_000 ) While the :erlang.memory() returns a keyword list with 9 entries, the above call will only produce three metrics, erlang.memory.total , erlang.memory.atom and erlang.memory.processes .","ref":"probes.html#defining-probes","title":"Probes - Defining probes","type":"extras"},{"doc":"If more control is desired, you can implement a probe module yourself. defmodule MyProbe do @behaviour Instruments.Probe # callback implementations... end # and then define the probe: Probe . define ( &quot;system.my_probe&quot; , :counter , module : MyProbe ) Your module is now a registered probe, and will receive all of the Probe callbacks.","ref":"probes.html#module-based-probes","title":"Probes - Module based Probes","type":"extras"},{"doc":"There are a couple optimizations that keep Instruments fast. ETS backed counters Probe counters actually increment or decrement a value in an ETS table, every fast_counter_report_interval milliseconds, the aggregated values are flushed to statsd. Furthermore, the ETS tables are sharded across schedulers and can be written to without any concurrency. Because of this, counters are effectively free and with a conservative flush interval, will put little pressure on your statsd server. IOData metric names Instruments uses macros to implement the metric names, and automatically converts interpolated strings into IOLists. This means you can have many generated names without increasing the amount of binary memory you're using. For example: def increment_rpc ( rpc_name ) , do : Instruments . increment ( &quot;my_module.rpc. \#{ rpc_name } &quot; ) will be rewritten to the call: def increment_rpc ( rpc_name ) , do : Instruments . increment ( [ &quot;my_module.rpc.&quot; , Kernel . to_string ( rpc_name ) ] ) If you wish, you may pass any IOData as the name of a metric. Sample Rates For histograms, measure calls and timings, the default sample rate is pegged to 0.1. This is so you don't accidentally overload your metrics collector. It can be overridden by passing sample_rate: float_value to your metrics call in the options.","ref":"performance.html","title":"Performance","type":"extras"}]